/*********************************************************************
 *	rbh:VAʐM
 *********************************************************************
 *	M荞݂gp.
 *	M荞݂͎gpȂ.
 *	荞݋֎~Ԃł̎Msꍇsci_RxChar()Ăяo.
 *
 *
 */
#include "monit.h"
#include "sci.h"

/*********************************************************************
 *	
 *********************************************************************
 */
#ifdef	_TINY

//	3694F20MHz
#define	CPU_FREQUENCY		20000000	// botNbNg.
#else

//	3048F16MHz
#define	CPU_FREQUENCY		16000000	// botNbNg.
//	SCI3  3048Fł SCI1 Ɋ蓖Ă.
#define	SCI3	SCI1
#define	SCR3	SCR
#endif


#define	INIT_BAUD			19200

#define	USE_SCI_INTERRUPT	(1)			// M荞݂gp.

#define	RXBUF_SIZE			16			// Mobt@TCY. 2ׂ̂.

#define	RXBUF_MASK		(RXBUF_SIZE-1)	// Mobt@index mask.



//	Mobt@\:
typedef	struct {
	char fifo[RXBUF_SIZE];	// FIFO
	char getptr;			// FIFOǂݏoʒu.
	char putptr;			// FIFO݈ʒu.
} SCI_RxBuf;

static	SCI_RxBuf sci_RxBuf;

/*********************************************************************
 *	rbhF{[[gݒ.
 *********************************************************************
 */
void sci_setBaud(int baud)
{
#if	0
	uchar n = 0;
	int   N = CPU_FREQUENCY / (32 * baud);

	while(N>=256) {	// BRR8bitxȂ̂ŁA256ȏゾvXP[[ɗ.
		n++;N >>= 2;	//vXP[[n ͂P1/4.
	}

	SCI3.SMR.BYTE = (n & 3);	// vXP[[ n
	SCI3.BRR      = (N - 1);	// JE^ 1 ȂlZbg.
#else
	// x߂邽߁ANQrbgʗɂ.
	uchar n = 0;
	int   N = CPU_FREQUENCY / ( (32/4) * baud);

	while(N>=(255*4)) {	// BRR8bitxȂ̂ŁA256ȏゾvXP[[ɗ.
		n++;N >>= 2;	//vXP[[n ͂P1/4.
	}

	SCI3.SMR.BYTE = (n & 3);	// vXP[[ n

	//N͂QrbgʗɂȂĂ.
	if(N & 2) {N=N+4;}			// ľܓ( bit1  1 Ȃ؂グ,łȂΐ؂̂ )
	SCI3.BRR      = ((N>>2) - 1);	// JE^ 1 ȂlZbg.
#endif
}

/*********************************************************************
 *	rbhF.
 *********************************************************************
 */
void sci_Init(int baud)
{
	SCI3.SCR3.BYTE = 0x00;
	sci_setBaud(baud);		// SMR,BRRݒ.
	Wait_msec(10);			// 1bitԂ҂. 110{[Ȃ 10mS.
	
	SCI3.SCR3.BYTE = 0x70;	// TIE=0,RIE,TE,RE = 1.

	sci_RxBuf.getptr = 0;
	sci_RxBuf.putptr = 0;
}
/*********************************************************************
 *	rbhFPoCgM.	荞݂gpȂ.
 *********************************************************************
 */
int sci_RxChar(void)
{
	uchar ssr = SCI3.SSR.BYTE;
	if(ssr & 0x38) {		// OER,PER,FER@eG[rbĝǂꂩOn?
		//G[.
//		SCI3.SSR.BIT.OER = 0;
//		SCI3.SSR.BIT.PER = 0;
//		SCI3.SSR.BIT.FER = 0;
		SCI3.SSR.BYTE=0;
		return -1;			// EOF
	}
	if(ssr & 0x40) {		// RDRF Mf[^WX^t.
		return SCI3.RDR;	// Mf[^󂯎.
	}
	return -1;		
}
/*********************************************************************
 *	rbhFPoCgM.
 *********************************************************************
 */

void sci_TxChar(char c)
{
	do{
		//	MrW[Ȃ҂.
	} while( !(SCI3.SSR.BYTE & 0x80) );		// TDRE Mf[^WX^GveB.

	SCI3.TDR = c;		// PM.
	SCI3.SSR.BYTE &= 0x7f;
}

/*********************************************************************
 *	rbhFPgetc
 *********************************************************************
 */
#if	USE_SCI_INTERRUPT			// M荞݂gp.

char read_ccr(void);

int sci_async_getc(void)
{
	SCI_RxBuf *rxbuf = &sci_RxBuf;
	int c = -1;
	uchar p = rxbuf->getptr;

	if( p != rxbuf->putptr ) {		// f[^ FIFOɑ݂.
		c = rxbuf->fifo[p];
		p++;p &= RXBUF_MASK;		// FIFOobt@i߂.
		rxbuf->getptr = p;
	}else{							// FIFO͋ł.
		if( read_ccr() & 0x80 )	{	// 荞݋֎~?
			return sci_RxChar();	// 荞݋֎~́ASCIM.
		}
	}
	return c;
}

//	荞ݏ̏ꍇ:
int sci_getc(void)
{
	int c;
	while(1) {
		c = sci_async_getc();
		if(c>=0) return c;
	}
}
#else

//	荞ݏȂ̏ꍇ:
int sci_getc(void)
{
	int c;
	while(1) {
		c = sci_RxChar();
		if(c>=0) return c;
	}
}

#endif

/*********************************************************************
 *	rbhFPputc
 *********************************************************************
 */
void sci_putc(char c)
{
	sci_TxChar(c);
}

/*********************************************************************
 *	rbhFG[
 *********************************************************************
 */
void sci_handle_err(void)
{
//	SCI3.SSR.BIT.OER = 0;
//	SCI3.SSR.BIT.PER = 0;
//	SCI3.SSR.BIT.FER = 0;
	SCI3.SSR.BYTE = 0;
}
/*********************************************************************
 *	rbhFMnh[
 *********************************************************************
 */
void sci_handle_Rx(void)
{
	uchar c = SCI3.RDR;	// Mf[^󂯎.
	SCI3.SSR.BYTE &= 0xbf;

	SCI_RxBuf *rxbuf = &sci_RxBuf;
	uchar  p = rxbuf->putptr;
	{
		rxbuf->fifo[p] = c;
		p++;p &= RXBUF_MASK;			// FIFOobt@i߂.

		if( p != rxbuf->getptr ) {		// o|C^ɒǂĂȂ.
			rxbuf->putptr = p;			// |C^XV.
		}
	}
}
/*********************************************************************
 *	rbhFMnh[
 *********************************************************************
 */
void sci_handle_Tx(void)
{
	//	̂ƂȂɂȂ.
}
#ifdef	_TINY
/*********************************************************************
 *	rbhF荞݃nh[
 *********************************************************************
 */
Interrupt void sci_handler( void )
{
	uchar ssr = SCI3.SSR.BYTE;
	if(	ssr & 0x38 ) {
		sci_handle_err();
	}else{
		if(	ssr & 0x40 ) {	// RDRF Mf[^WX^t.
			sci_handle_Rx();
		}
		if(	ssr & 0x80 ) {	// TDRE Mf[^WX^GveB.
			sci_handle_Tx();
		}
	}
}
#else
/*********************************************************************
 *	rbhFM荞݃nh[
 *********************************************************************
 */
Interrupt void sci_rx_handler( void )
{
	sci_handle_Rx();
}
/*********************************************************************
 *	rbhFM荞݃nh[
 *********************************************************************
 */
Interrupt void sci_error_handler( void )
{
	sci_handle_err();
}
#endif
/*********************************************************************
 *
 *********************************************************************
 */

char getDebugChar(void)
{
	return sci_getc();
}

/*********************************************************************
 *
 *********************************************************************
 */
//
//	MȂƂ (-1)
//
int getDebugCharAsync(void)
{
	return sci_async_getc();
}

/*********************************************************************
 *
 *********************************************************************
 */
void putDebugChar(char ch)
{
	return sci_putc(ch);
}
